#!/usr/bin/python
import pygame_engine
import pygame
from polygon_world import Polygon_world, Polygon , Polygon_editor
import polygon_world
from world_object import *
import world_object
import pygame
import string
from math_util import vector3
from colors import * 
from pygame.locals import *
import rope_guy
import string_drawer
import string
import functools
from new import instancemethod
import navigator
import sys
import message_dictionary

level_edit = False  # set to false for release
edit_mode = False

class Level:
    def __init__ (self,engine):
        self.objects = []
        self.engine = engine
        self.middle_to_screen_edge_x = vector([engine.width/2,0])
        self.middle_to_screen_edge_y = vector([0,engine.height/2])
        self.complete = False
     
    def tick (self, t):
        if (self.engine.message_timeout <= 0 and self.complete):
            self.engine.back_to_map()
            return
        for o in self.objects:
            o.tick(t)
    def add_object (self,o):
        self.objects.append(o)

    def remove_object (self,o):
        self.objects.remove(o)
        
    def render (self):
        #for p in self.world.get_polys():
        #    for l in p.get_lines():
        #        l_screen = [self.engine.to_screen(x) for x in l]
        #        pygame.draw.line(self.engine.surface, red, l_screen[0].v, l_screen[1].v, 1) 
        for l in self.world.line_getter(self.engine.focus.pos,self.middle_to_screen_edge_x,self.middle_to_screen_edge_y):
            l_screen = [self.engine.to_screen(x) for x in l]
            
            color = polygon_world.poly_colours[l[2].type]
            pygame.draw.line(self.engine.surface, color, l_screen[0].v, l_screen[1].v, 1) 
        
        for o in self.objects:
            o.draw()
        if (edit_mode):
            top_left = self.engine.to_screen(vector([0,0]))
            bottom_right = self.engine.to_screen(vector(self.world.size))
            for corner in [top_left,bottom_right]:
                if (corner.v[0] > 0 and corner.v[0] < self.engine.width):
                    pygame.draw.line(self.engine.surface, white,[corner.v[0],0],[corner.v[0],self.engine.height])
                if (corner.v[1] > 0 and corner.v[1] < self.engine.height):
                    pygame.draw.line(self.engine.surface, white,[0,corner.v[1]],[self.engine.width,corner.v[1]])
    def mark_complete(self):
        self.complete = True
        
            

level_files = ["training.lvl","level1.lvl","level2.lvl","level3.lvl","level4.lvl","level5.lvl"]
#level_files = ["quick.lvl","quick.lvl","quick.lvl","quick.lvl","quick.lvl","quick.lvl"]
md = message_dictionary.message_dictionary[0]    
class Test_engine (pygame_engine.Engine):
    
    def __init__ (self):
        pygame_engine.Engine.__init__ (self,640,480,"The Ascent Of Mount Knot")
        g = vector ([0,900])
        string.default_gravity = g
        world_object.gravity = g
        rope_guy.set_string_maker (self.string_maker)
        self.current_message = ""
        
        self.add_key_handler (K_UP,self.up)
        self.add_key_handler (K_DOWN,self.down)
        self.add_key_handler (K_LEFT,self.left)
        self.add_key_handler (K_RIGHT,self.right)
        self.add_key_handler (K_SPACE,None)
        self.add_key_handler (K_RETURN,None)
        self.add_key_handler (K_e,None)
        self.add_key_handler (K_l,None)
        self.add_key_handler (K_w,None)
        self.add_key_handler (K_s,None)
        self.add_key_handler (K_a,None)
        self.add_key_handler (K_d,None)
        self.add_key_handler (K_x,None)
        
        self.text_font = pygame.font.Font (pygame.font.get_default_font(),24)

        self.navigator = navigator.Navigator(self)
        #self.current_renderer = self.navigator.render
        self.level = None
       
        self.activity = self.navigator
        
        self.mouse_down = None
        self.r_mouse_down = None
        
        self.message_timeout = 0.0
        self.last_story_message = 0
        self.console_timeout = pygame.time.get_ticks()
        
        if (level_edit and len(sys.argv) == 2):
            level_files[0] = sys.argv[1]
            self.start_level(0)
        
    def start_level (self,index):    
        global md
        self.level = Level (self)
        self.level.world = Polygon_world ([5000,5000])
        f = open (level_files[index],"rb")
        self.level.world.read(f)
        f.close()
        md = message_dictionary.message_dictionary[index]
        
        self.activity = self.level
        
        
        
        self.guy = rope_guy.Rope_guy(vector([520,4900]),self)
        self.level.objects.append (self.guy)
        self.guy.make_heavy()
        self.guy.set_line_getter(self.level.world.line_getter)
        self.guy.is_sticky = is_sticky
       
        self.last_story_message = 0
    
        self.screen_pos = vector([-200,0])
    
        self.focus = self.guy
        
        if (level_edit):
            self.level_editor = Polygon_editor (self.level.world)
            self.edit_point = World_object (vector([20,40]))
            
        self.mouse_down = self.point_to_world_forwarder (self.fire)
        self.r_mouse_down = self.point_to_world_forwarder (self.action)

    def back_to_map (self):
        self.navigator.level_complete()
        self.activity = self.navigator

    
    def tick (self , t):
        global edit_mode
        self.activity.tick(t)
        
        if (self.activity == self.navigator and self.navigator.level_selected):
            self.start_level (self.navigator.selected_level_index)

        self.message_timeout -= t
        if (self.message_timeout < 0):
            self.current_message = ""
            if (self.current_message != 0):
                self.try_next_message ()
            
        
        if (level_edit):
            if (self.is_key_pressed (K_e)):
                self.mouse_down = self.point_to_world_forwarder (self.level_editor.mouse_down)
                self.r_mouse_down = self.point_to_world_forwarder (self.level_editor.r_mouse_down)
                edit_mode = True
                self.focus = self.edit_point
                self.edit_point.pos = self.guy.pos.clone()
            elif (self.is_key_pressed (K_l)):
                self.mouse_down = self.point_to_world_forwarder (self.fire)
                self.r_mouse_down = self.point_to_world_forwarder (self.action)
                edit_mode = False
                self.focus = self.guy
            if (edit_mode):
                self.console_timeout -= t
                if (self.is_key_pressed(K_w)):
                    self.edit_point.pos += vector([0,-10])
                if (self.is_key_pressed(K_s)):
                    self.edit_point.pos += vector([0,10])
                if (self.is_key_pressed(K_a)):
                    self.edit_point.pos += vector([-10,0])
                if (self.is_key_pressed(K_d)):
                    self.edit_point.pos += vector([10,0])
                if (self.is_key_pressed(K_x) and self.console_timeout + 1000 < pygame.time.get_ticks()):
                    self.console()
                    self.console_timeout = pygame.time.get_ticks()
            else:
                if (self.is_key_pressed(K_w)):
                    self.guy.pos += vector([0,-10])
                    self.guy.vel = vector([0,0])
                if (self.is_key_pressed(K_s)):
                    self.guy.pos += vector([0,10])
                    self.guy.vel = vector([0,0])
                if (self.is_key_pressed(K_a)):
                    self.guy.pos += vector([-10,0])
                    self.guy.vel = vector([0,0])
                if (self.is_key_pressed(K_d)):
                    self.guy.pos += vector([10,0])
                    self.guy.vel = vector([0,0])
     
    def fire(self,p):
        self.guy.fire (p-self.guy.pos)
    def action(self,p):
        self.guy.action (p-self.guy.pos)

    def draw_text (self,t,y):
        s = self.text_font.render (t,False,white)
        self.surface.blit (s,[0,y])        
    def story_message (self,m_index,m="?"):
        
        if (m_index>self.last_story_message):
            
            if (md.has_key(m_index)):
                m = md[m_index]
            
            self.current_message = m 
            self.message_timeout = 10.0
            self.last_story_message = m_index
            if m_index == 200:
                self.level.mark_complete()
                self.guy.complete = True
    def try_next_message(self):
        if (md.has_key(self.last_story_message+1)):
            self.story_message (self.last_story_message+1)
        
    def render (self):
        self.surface.fill (black)
        self.activity.render()
        m = self.current_message
        y = 0
        while(1):
            index = m.find('\n')
            if (index == -1):
                self.draw_text(m,y)
                break
            
            part = m[:index]
            m = m[index+1:]
            self.draw_text(part,y)
            y += 24
            
        
        
   
        
    
    def string_maker (self,start,step,len):
        s = string.String (start.clone(),step,len)
        s.draw = instancemethod( string_drawer.string_drawer (self), s, string.String) 


        return s

     
    
    def save (self,fname):
        f= open (fname,"wb")
        self.level.world.write(f)
        f.close()
    def set_poly_message(self,index,message):
        self.level_editor.set_poly_message(index,message)
    def spmi(self,index):
        if (index == 0):
            self.level_editor.message = None
        self.level_editor.set_poly_message(index,"?")
    def ts (self):
        self.guy.pos = vector([520,4900])
        self.guy.vel = vector([0,0])
    def up (self,s):
        pass
    def down (self,s):
        pass
    def left (self,s):
        pass
    def right (self,s):
        pass

def is_sticky (l):
    return l[2].type != polygon_world.POLY_TYPE_NONSTICK
        


        
test_engine = Test_engine ()


test_engine.run()
