import world_object
from math_util import vector
import pygame
from colors import *
from pygame.locals import *

aiming_distance_pixels = 100
normal_weight = 100
rock_carrying_weight = 400
class Rope_guy (world_object.Circle_collider_object):
    def __init__(self,pos,engine):
        world_object.Circle_collider_object.__init__(self,pos)
        self.engine = engine
        self.rope = None
        self.mass = rock_carrying_weight
        self.inv_mass = 1.0 / self.mass
        self.fire_count_down = 0
        self.firing = False
        self.firing_interval = 0.0099
        
        self.max_max_rope_length = 12
        self.max_rope_length = self.max_max_rope_length
        self.impulse_vector_len =  7000#5670
        
        self.impulse_factor = 1.0  #reduces as more of the rope is out
        self.impulse_factor_reduction = 0.85
        self.pull_up_timer = 0
        self.rope_landed = False
        self.jump_vector = vector([0,-300])
        self.jump_time_out = 0
        self.jump_released = True
        
        self.complete = False
        #self.ready_to_go_back_to_map = False
    def action (self, p):
        if (self.rope):
            self.discard_rope()
    def fire (self, p):
        if (self.rope):
            self.discard_rope()
            
        self.rope_landed = False
        self.rope = Rope_guy.string_func(self.pos,vector([0,0]),2)
        power = max (0.3,min (1.0,(p.len() / aiming_distance_pixels)))
        self.max_rope_length = self.max_max_rope_length * power 
        
        self.impulse_vector = p.normalize() * self.impulse_vector_len
        self.impulse_factor = power
        self.apply_fire_impulse (self.rope.get_end(1))
        self.fire_count_down = self.firing_interval
        self.firing = True
        self.engine.add_object (self.rope)
     
    def apply_fire_impulse (self,stringlet):
        i = self.impulse_vector * self.impulse_factor
        give_impulse (stringlet,i)
        give_impulse (self,i*-1)
        self.impulse_factor *= self.impulse_factor_reduction
        
    def discard_rope (self):
        self.engine.remove_object(self.rope)
        self.rope = None
        self.firing = False
    def draw (self):
        box_screen = self.engine.to_screen (self.bounding_box())
        pygame.draw.ellipse(self.engine.surface, blue, box_screen,1)
        
     
    def tick (self,t):
        if (self.complete):
            return
        if (self.rope):
            f = 1.0
            if (self.engine.is_key_pressed(K_UP)):
                f = 1.2
            self.vel += self.rope.get_end(0).get_tension() * (self.inv_mass *t*f)
        world_object.Circle_collider_object.tick(self,t)
        if (self.collided_line and self.collided_line[2].message):
            self.engine.story_message ( self.collided_line[2].message_index ,self.collided_line[2].message)
        
        power = 2000
        
        if (self.firing):
            self.fire_count_down -= t
            if (self.fire_count_down < 0):
                self.fire_count_down = self.firing_interval
                assert self.rope
                self.rope.extend_end(0)
                self.apply_fire_impulse (self.rope.stringlets[1])
                if (self.rope.get_len() >= self.max_rope_length):
                    self.firing = False
                    self.pull_up_timer = 0
                    
        if (self.rope):
            if (not self.firing):
                if (self.engine.is_key_pressed(K_UP)):
                    self.pull_up_timer+= t
                elif (self.engine.is_key_pressed(K_DOWN)):
                    self.pull_up_timer-= t
                    
                if (self.pull_up_timer > 0.001):
                    self.pull_up_timer = 0
                    if (self.rope.get_len() >2):
                        self.rope.shorten()
                if (self.pull_up_timer < -0.001):
                    self.pull_up_timer = 0
                    if (self.rope.get_len() <= self.max_max_rope_length):
                        self.rope.lengthen(self.rope.get_len() < self.max_max_rope_length)
                
            self.rope.set_end_pos (0,self.pos.clone())
            self.rope.set_end_vel (0,self.vel.clone())
            
            if (not self.rope_landed):
                land = self.get_nearest_land (self.rope.get_end(1).pos,10,self.is_sticky)
                if (land):
                    self.rope.get_end(1).fixed = True
                    self.rope.get_end(1).pos = land
                    self.rope_landed = True
            if (self.engine.is_key_pressed(K_SPACE)):
                self.set_mass(100) 
            #if (self.engine.is_key_pressed(K_LEFT)):
            #    self.set_mass(rock_carrying_weight) 
                
        self.jump_time_out -= t
        
        if (self.on_ground):
            move_power = power
        else:
            move_power = power * 0.2
        if (self.engine.is_key_pressed(K_LEFT)):
            self.vel += vector ([-move_power,0])*t
        if (self.engine.is_key_pressed(K_RIGHT)):
            self.vel += vector ([move_power,0])*t
        if (self.on_ground and not self.rope):
            if (self.engine.is_key_pressed(K_UP) and self.jump_time_out < 0 and self.jump_released):
                self.vel += self.jump_vector
                self.jump_time_out = 0.3
                self.jump_released = False
        if (not self.engine.is_key_pressed(K_UP)):
            self.jump_released = True

    #static functnions:
def give_impulse(obj, impulse_vector):
    obj.vel += impulse_vector * obj.inv_mass
def set_string_maker (string_func):
    '''set the func rope guy will call to make a string'''
    Rope_guy.string_func = string_func