import pygame
from colors import *
import functools
from math_util import vector
from operator import __add__

b_spline_matrix = [[  -1,  3, -3,  1],
                   [   3, -6,  3,  0],
                   [  -3,  0,  3,  0],
                   [   1,  4,  1,  0]]
b_spline_matrix_t = [[  -1,  3, -3,  1],
                     [   3, -6,  0,  4],
                     [  -3,  3,  3,  1],
                     [   1,  0,  0,  0]]

def draw_b_spline (control_points,prec, point_list,skip_first = False):
    for i in range (prec+1):
        if (i==0 and skip_first):
            continue
        t = float(i)/prec
        t2 = t**2
        t3 = t**3
        v = [t3/6,t2/6,t/6,1.0/6]
        v2 = [reduce(__add__,[a[0]*a[1] for a in zip(v,c)]) for c in b_spline_matrix_t]
        
        new_point = reduce (__add__,[a[0]*a[1] for a in zip(control_points,v2)])   
        point_list.append(new_point)
        
class string_drawer_:  # b-spline version turned out to be to processor expensive
    def __init__ (self,engine):
        self.engine = engine
        
    def __call__ (self,string):
        
        
        
        control_points = []
        points = []
        skip_first = False
        for p in string.positions():
            ps = self.engine.to_screen (p)
            if (len(control_points) == 0):
                control_points.append(ps)
                control_points.append(ps)
            
            control_points.append(ps)
            if (len(control_points) == 4):
                draw_b_spline (control_points,2,points,skip_first)
                skip_first = False
                control_points.pop(0)
        control_points.append(ps)
        control_points.pop(0)
        control_points.append(ps)       
        draw_b_spline (control_points,1,points,skip_first)
        
        
        coords = [a.v for a in points]
        
        pygame.draw.lines (self.engine.surface, yellow, False, coords)
        #pygame.draw.lines (self.engine.surface, light_blue, False, [a.v for a in control_points])
        
class string_drawer:
    def __init__ (self,engine):
        self.engine = engine
        
    def __call__ (self,string):
        
        points = []
        
        for p in string.positions():
            ps = self.engine.to_screen (p)
             
            points.append(ps)
        
        
        coords = [a.v for a in points]
        
        pygame.draw.lines (self.engine.surface, yellow, False, coords)
        
